using System;
namespace CosnoleApp1
{
    class Project
    {

        static void Main()
        {
            int n = int.Parse(Console.ReadLine());
            string[] unos = Console.ReadLine().Split();
            int[] niz = new int[n];
            for (int i = 0; i < n; i++)
            {
                niz[i] = int.Parse(unos[i]);
            }
            int q = int.Parse(Console.ReadLine());
            unos = Console.ReadLine().Split();
            int pocetak1, kraj1;
            int p;
            bool provera;
            bool izbrisao;
            while (q > 0)
            {
                pocetak1 = int.Parse(unos[0]) - 1;
                kraj1 = int.Parse(unos[1]) - 1;

                provera = true;
                izbrisao = false;
                p = niz[pocetak1];
                if ((kraj1 - pocetak1 > 1) && (p > niz[pocetak1 + 1]) && (p > niz[pocetak1 + 2]))
                {
                    p = niz[pocetak1 + 1];
                    pocetak1++;
                    izbrisao = true;
                }

                for (int i = pocetak1; i <= kraj1; i++)
                {


                    if (niz[i] < p && izbrisao == false && i < kraj1)
                    {
                        izbrisao = true;
                        if (p > niz[i + 1]) p = niz[i];

                    }


                    else if ((niz[i] < p && izbrisao == true))
                    {
                        provera = false;
                        break;
                    }
                    else p = niz[i];

                }
                if (provera) Console.WriteLine("DA");
                else Console.WriteLine("NE");
                q--;
                unos = Console.ReadLine().Split();
            }
        }
    }
}